CON
  _clkmode = xtal1 + pll16x ' external clock via USB
  _xinfreq = 6_000_000
'  _clkmode = RCFAST ' internal fast clock mode (MPROG)
  
  LedRouge = 1
  LedVerte = 2
  LedInterne = 27

  DataX1 = 13 ' p07 violet
  DataY1 = 0  ' p29 gris
  
  AddrA1 = 26 ' p28 blanc  
  AddrB1 = 25 ' p27 noir  
  AddrC1 = 24 ' p26 marron (1)

  ' erreur ici
  
  DataX2 = 3  ' p35 vert
  DataY2 = 5  ' p37 jaune
    
  AddrA2 = 4  ' p36 orange  
  AddrB2 = 6  ' p38 rouge  
  AddrC2 = 7  ' p39 marron (2)

  Offset = 13

  _i2cSDA = 9
  _i2cSCL = 10
  _driveSCLLine = 1

  CMD_NOSIGNAL_RED38 = 1  
  CMD_NOSIGNAL_GREEN34 = 2  
  CMD_GOOD_RED38_SIGNAL = 4
  CMD_GOOD_GREEN34_SIGNAL = 8  
  CMD_BAD_RED38_SIGNAL = 16  
  CMD_BAD_GREEN34_SIGNAL = 32  
  CMD_NEAR = 64  
  
OBJ
  text : "vga_text"
  i2cObject   : "i2cObject" 
  
VAR
  long command
  long delayTime
  long Stack1[9]             'Stack space for new cog
  long Stack2[9]             'Stack space for new cog
  long Stack3[9]             'Stack space for new cog
  byte cadran[4]
  long cadran38
  long cadran34
  byte distance
  byte direction
  byte mem[32]
  byte resu[32]
  long tps[32]

PUB Main | i, j, k, m, n, c,t,r
  command := CMD_NOSIGNAL_RED38 | CMD_NOSIGNAL_GREEN34  
  dira[AddrA1] ~~
  dira[AddrB1] ~~
  dira[AddrC1] ~~
  dira[DataX1] ~
  dira[DataY1] ~

  dira[AddrA2] ~~
  dira[AddrB2] ~~
  dira[AddrC2] ~~
  dira[DataX2] ~
  dira[DataY2] ~

  i2cObject.init(_i2cSDA,_i2cSCL,_driveSCLLine)

'  cognew(Blink(LedRouge), @Stack1)
'  cognew(Blink(LedVerte), @Stack2)
'  cognew(Blink(LedInterne), @Stack3)
  cognew(Blink,@Stack1)

  'start term
  text.start(16)
  text.str(string($A,1,$B,1,"38kHz:"))
  text.str(string($A,1,$B,2,"34kHz:"))  
'  text.str(string($C,1,$A,24,$B,9,"38k"))
'  text.str(string($C,5,$A,19,$B,12,"34k",$C,7))
'  text.str(string($C,6,$A,3,$B,9,"<-"))
  'text.str(string(13,"IR 38kHz :",13,13,$C,5))
'  repeat 14
'    text.out(" ")
'  repeat i from $0E to $FF
'    text.out(i)
'  text.str(string($C,6,"     Uses internal ROM font     ",$C,2))
'  repeat
  c := 1
'  i := 0
'  outa[AddrA1] := i & 1 
'  outa[AddrB1] := (i & 2) >> 1
'  outa[AddrC1] := (i & 4) >> 2
'   
'  outa[AddrA2] := i & 1
'  outa[AddrB2] := (i & 2) >> 1
'  outa[AddrC2] := (i & 4) >> 2
  repeat
    Calcul
    'c := -c
    'if c>0
    '  text.str(string($C,6))
    'else
    '  text.str(string($C,2))
    repeat i from $0 to $7
      outa[AddrA1] := i & 1 
      outa[AddrB1] := (i & 2) >> 1
      outa[AddrC1] := (i & 4) >> 2
   
      outa[AddrA2] := i & 1
      outa[AddrB2] := (i & 2) >> 1
      outa[AddrC2] := (i & 4) >> 2

      m := 8
      j := i + m
      
      if j < m+4
        k := m-(j-m)
      else
        k := m-3+(j-(m+4))

      if j < m+4
        n := m+(j-m) + 1
      else
        n := m+(m+1)+3-(j-(m-4))
                             
      'text.str(string($A,2+Offset,$B,2,"K="))
      'text.hex(k, 2)
      'text.str(string(" J="))
      'text.hex(j, 2)
        
      text.str(string($C,1))
      ' srie des 38
      text.str(string($A))
      text.out(3*m-j-1)
      text.str(string($B))
      text.out(k)
      DisplayBit(DataX1,i)
      text.str(string($A))
      text.out(3*m-j-1+14)
      text.str(string($B))
      text.out(k)
      text.hex(ina[DataX1] & 1, 1)

      text.str(string($A))
      text.out(j)
      text.str(string($B))
      text.out(n)
      DisplayBit(DataY1,i+8)
      text.str(string($A))
      text.out(j+14)
      text.str(string($B))
      text.out(n)
      text.hex(ina[DataY1] & 1, 1)

      text.str(string($C,5))

      text.str(string($A))
      if 3*m-j-1 < 12
        text.out( 3*m-j-1 -2)
      else
        text.out( 3*m-j-1 +2)
      text.str(string($B))
      text.out(k)

      DisplayBit(DataX2,i+16)
      
      text.str(string($A))
      if 3*m-j-1 < 12
        text.out( 3*m-j-1 -2+14)
      else
        text.out( 3*m-j-1 +2+14)
      text.str(string($B))
      text.out(k)
      text.hex(ina[DataX2] & 1, 1)

      ' 34kHz
      text.str(string($A))
      if j < 12
        text.out(j-2)
      else
        text.out(j+2)
      text.str(string($B))
      text.out(n)

      DisplayBit(DataY2,i+24)
      
      text.str(string($A))
      if j < 12
        text.out(j-2+14)
      else
        text.out(j+2+14)
      text.str(string($B))
      text.out(n)
      text.hex(ina[DataY2] & 1, 1)


      'waitcnt(delayTime)
        
      'text.hex(ina[DataY1], 2)

      ' 2
      'text.str(string($A,2+Offset,$B,2,"Ad2="))
      'text.hex(i, 2)
      'text.str(string($A,2+Offset,$B,3,"X2 ="))
      'text.hex(ina[DataX2], 2)
      'text.str(string($A,2+Offset,$B,4,"Y2 ="))
      'text.hex(ina[DataY2], 2)

PUB GetMax(i) : k | t,u
      t := 0
      k := 1  
      u := resu[5+i]+resu[6+i]+resu[7+i]+resu[8+i]
      if u => t
        t := u
        k := 2
      u := resu[12+i]+resu[11+i]+resu[10+i]+resu[9+i]
      if u => t
        t := u
        k := 3
      u := resu[12+i]+resu[13+i]+resu[14+i]+resu[15+i]
      if u => t
        t := u
        k := 4
      u := resu[2+i]+resu[3+i]+resu[4+i]+resu[5+i]
      if u => t
        t := u
        k := 1
      u := resu[15+i]+resu[16+i]+resu[1+i]+resu[2+i]
      if u => t
        k := 0
      return k

PUB Calcul | i,conf38,conf34,j,ok34,ok38
  ok38 := ok34 := 0
  
  conf38 := 0
  repeat i from 1 to 16
    conf38 += resu[i]
  text.str(string($C,1,$A,1,$B,3))
  if conf38 == 0  
    text.str(string($C,1,$A,8,$B,1,  "RAS"))
    command &= !CMD_NOSIGNAL_RED38 & !CMD_BAD_RED38_SIGNAL  
    command |= CMD_NOSIGNAL_RED38  
  else  
    if conf38 > 8  
      text.str(string($C,1,$A,8,$B,1,"INV"))
      command &= !CMD_GOOD_RED38_SIGNAL & !CMD_NOSIGNAL_RED38  
      command |= CMD_BAD_RED38_SIGNAL  
    else
      ok38 := 1
      text.str(string($C,1,$A,8,$B,1))
      cadran38 := GetMax(0)
'      text.str(string(" C:"))
      text.dec(cadran38)
      text.str(string(" "))
      text.dec(conf38)
'      text.str(string("/3"))          
      command &= !CMD_BAD_RED38_SIGNAL & !CMD_NOSIGNAL_RED38  
      command |= CMD_GOOD_RED38_SIGNAL  

  conf34 := 0
  repeat i from 17 to 32
    j := resu[i] 
    conf34 += j & 1
  if conf34 == 0  
    text.str(string($C,5,$A,8,$B,2,  "RAS"))
    command &= !CMD_NOSIGNAL_GREEN34 & !CMD_BAD_GREEN34_SIGNAL  
    command |= CMD_NOSIGNAL_GREEN34  
  else  
    if conf34 > 8  
      text.str(string($C,5,$A,8,$B,2,"INV"))
      command &= !CMD_GOOD_GREEN34_SIGNAL & !CMD_NOSIGNAL_GREEN34  
      command |= CMD_BAD_GREEN34_SIGNAL  
    else
      ok34 := 1
      text.str(string($C,5,$A,8,$B,2))
      cadran34 := GetMax(16)
'      text.str(string(" C:"))
      text.dec(cadran34)
      text.str(string(" "))
      text.dec(conf34) 
'      text.str(string("/3"))
      command &= !CMD_BAD_GREEN34_SIGNAL & !CMD_NOSIGNAL_GREEN34  
      command |= CMD_GOOD_GREEN34_SIGNAL  

  Solution(conf38,conf34,ok38,ok34,cadran34,cadran38)

PUB Solution(conf38,conf34,ok38,ok34,_cadran34,_cadran38)          
  if ok34 == 1 and ok38 == 1
    if conf38 > conf34
      distance := 3-((conf38*3)/8)
      direction := _cadran38
    else
      distance := 3-((conf34*3)/8)
      direction := _cadran34

 ' text.str(string($C,7,$A,8,$B,3))
 ' text.str(string(" C:"))
 ' text.dec(direction)
 ' text.str(string(" D:"))
 ' text.dec(distance)
'  text.str(string("/3"))
  if distance < 2
    command |= CMD_NEAR
  else
    command &= !CMD_NEAR
    
   
   

PUB DisplayBit(Data,i) | t,r
    t := (ina[Data] & 1)        
    if tps[i] > 6
      r := 1
    else
      r := 0
    if t == 0 and mem[i] == 1 and tps[i] < 8
      tps[i]++
    if t == 1 and mem[i] == 0 and tps[i] < 8
      tps[i]++
    if t == 0 and mem[i] == 0 and tps[i] > 0
      tps[i]--
    if t == 1 and mem[i] == 1 and tps[i] > 0
      tps[i]--
    mem[i] := t

    resu[i] := r 
    if r == 1   
      text.str(string("X"))
    else         
      text.str(string("."))
     

  
PUB Blink
  dira[LedInterne]~~
  dira[LedRouge]~~
  dira[LedVerte]~~
  repeat
    if (command & CMD_NOSIGNAL_RED38) and (command & CMD_NOSIGNAL_GREEN34)
      outa[LedRouge]~
      outa[LedVerte]~
      outa[LedInterne] := !outa[LedInterne]
      delayTime := cnt + 20_000_000
      waitcnt(delayTime)
    else
      if command & CMD_NEAR
        outa[LedInterne]~
      else
        outa[LedInterne]~~      

      if command & CMD_NOSIGNAL_RED38
        outa[LedRouge]~
      else
        if command & CMD_BAD_RED38_SIGNAL
          outa[LedRouge]~~
        else
          if command & CMD_GOOD_RED38_SIGNAL
            outa[LedRouge] := !outa[LedRouge]
            delayTime := cnt + 20_000_000
            waitcnt(delayTime)
           
      if command & CMD_NOSIGNAL_GREEN34
        outa[LedVerte]~
      else
        if command & CMD_BAD_GREEN34_SIGNAL
          outa[LedVerte]~~
        else
          if command & CMD_GOOD_GREEN34_SIGNAL
            outa[LedVerte] := !outa[LedVerte]
            delayTime := cnt + 20_000_000
            waitcnt(delayTime)
           

